<template lang="pug">
  .root
    ul.masonry-container.container(
      v-masonry
      transition-duration="0s"
      item-selector=".item"
      :data-column="column"
    )
      shower-item.item(
        v-for="(item,index) in photos"
        v-masonry-tile
        v-bind:key="index"
        :style="{ transitionDelay: `${item.seed}s`}"
        :index="index"
        :item="item"
        :fadeOut="fadeOut"
      )
</template>

<script>
import Vue from 'vue'
import showerConfig from '@/config/shower'
import { VueMasonryPlugin } from 'vue-masonry'
import { functions } from 'firebase'
Vue.use(VueMasonryPlugin)
import arrayShuffle from '@/util/shuffle'

import ShowerItem from '@/components/molecules/ShowerItem'

export default {
  components: {
    ShowerItem
  },
  props: {
    // 定数として持っておく
    column: {
      type: Number,
      default: showerConfig.column
    },
    margin: {
      type: Number,
      default: 10
    },
    photos: {
      type: Array,
      default: () => []
    },
    fadeOut: false
  },
  data: () => {
    return {
      // dataでもっとく
      flame: 0,
      items: [],
      shuffleTimer: null,
    }
  },
  mounted: function() {
    this.maxWidth = (window.innerWidth + this.margin) / this.column - this.margin
    console.log('mounted')
  },
  created: function() {
    console.log('created')
    // this.init()
  },
}
</script>

<style lang="stylus" scoped>
$gap = 10px
.addButton 
  position absolute
  top 0
  left 0

.root
  // border: solid 1px $c-green
  font-size: $fz-base
  position: relative
  padding: 0 ($gap/2)
  box-sizing: border-box
  .container
    margin: 0 auto
    justify-content: center
    flex-wrap: wrap
    box-sizing: border-box
    position relative
    for $num in 2 ... 7
      &[data-column=\"{$num}\"]
        $w = ( 100 / $num )%
        $gapSum = $gap + ( $gap / $num )
        .item
          width: "calc( %s - %s )" % ($w $gapSum)
  .item
    margin: ($gap / 2)
</style>
